from GMEComComponent import GMEComComponent

# Requires Udm 3.2.10 or later
_metagme_udm_xml = r'C:\Users\ksmyth\Documents\GReAT\Libraries\MetaGMEAPI\MetaGME.xml'
_clsid = "{INSERT-GUID-HERE}"

class UdmTesting(GMEComComponent):

    # Component specific parts for COM registration
    _comname_ = "UdmTesting"
    _comp_version_ = "1.0"
    _reg_clsid_ = _clsid
    _reg_iconfile_ = "pygme.ico"
    
    _reg_desc_ = _comname_
    _reg_progid_ = "MGA.PythonInterpreter.UdmTesting"
    _reg_verprogid_ = "MGA.PythonInterpreter.UdmTesting.1.0"
    _reg_class_spec_ = "%s.%s" % (__module__, _comname_)

    # Component specific parts for GME registration
    _tooltip_ = "My Python Interpreter"
    _paradigm_ = "MetaGME"

    def InvokeEx(self, project, currentobj, selectedobjs, param):
        super(self.__class__, self).InvokeEx(project)
        aborted = False
        try:
            self.project.BeginTransaction(self.project.CreateTerritory(None, None, None))
            currentobj = currentobj and self.mga.IMgaModel(currentobj)

            # component work goes here
            self.Logger("Python component: %s" % self._comname_)
            
            # Begin Udm-specific code
            import sys
            import os
            import os.path
            if os.environ.has_key("UDM_PATH"):
                sys.path.append(os.path.join(os.environ["UDM_PATH"], "bin"))
            else:
                sys.path.append(r"C:\Program Files\ISIS\Udm\bin")
            import udm
            meta_dn = udm.SmartDataNetwork(udm.uml_diagram())
            meta_dn.open(_metagme_udm_xml, "")
            meta = udm.map_uml_names(meta_dn.root)
            dn = udm.SmartDataNetwork(meta_dn.root)
            dn.open(project, "")
            def message(m):
                print m
                self.Logger(m)
            message(dn.root.name)
            message(" ".join((o.name for o in dn.root.children())))
            if currentobj:
                message("currentobj: " + dn.convert_gme2udm(currentobj).name)
        finally:
            if not aborted:
                self.project.CommitTransaction()
